include: "/.gitlab/ci/*.yml"

stages:
  - test
  - release

variables:
  GO_BUILD_VERSION: "1.21"

on_push_test:
  stage: test
  image: golang:${GO_VERSION}-alpine
  rules:
    - if: "$CI_PIPELINE_SOURCE == 'merge_request_event' || $CI_PIPELINE_SOURCE == 'push'"
  parallel:
    matrix:
      - GO_VERSION: [ "1.21" ]
  tags:
    - docker
  script: |
    apk add bash build-base git

    make test-cov

on_push_pre_release:
  stage: release
  image: docker:latest
  rules:
    - if: "($CI_PIPELINE_SOURCE == 'merge_request_event' || $CI_PIPELINE_SOURCE == 'push') && $CI_COMMIT_TAG =~ /^v/"
  tags:
  - docker
  variables:
    DOCKER_TAG: "${CI_COMMIT_TAG}-rc.${CI_COMMIT_SHA}"
  before_script:
    - echo "$REGISTRY_PASS" | docker login -u "$REGISTRY_USER" --password-stdin $CI_REGISTRY
  after_script:
    - docker logout $CI_REGISTRY
  script: |
    apk add bash helm make tar yq

    echo "${CI_COMMIT_TAG}" > VERSION

    docker build -t gardener-extension-provider-warren:latest .

    docker tag gardener-extension-provider-warren:latest ${CI_REGISTRY}/warrenio/library/gardener-extension-provider-warren:${DOCKER_TAG}

    docker push ${CI_REGISTRY}/warrenio/library/gardener-extension-provider-warren:${DOCKER_TAG}

    VERSION="${DOCKER_TAG}" make generate-controller-registration
    mv controller-registration.yaml rc-controller-registration.yaml
  artifacts:
    name: rc-controller-registration
    paths:
      - rc-controller-registration.yaml

on_push_release:
  stage: release
  when: manual
  image: docker:latest
  rules:
    - if: "($CI_PIPELINE_SOURCE == 'merge_request_event' || $CI_PIPELINE_SOURCE == 'push') && $CI_COMMIT_TAG =~ /^v/"
  tags:
  - docker
  before_script:
    - echo "$REGISTRY_PASS" | docker login -u "$REGISTRY_USER" --password-stdin $CI_REGISTRY
  after_script:
    - docker logout $CI_REGISTRY
  script: |
    apk add bash helm make tar yq

    echo "${CI_COMMIT_TAG}" > VERSION

    wget -O /usr/bin/release-cli "https://gitlab.com/api/v4/projects/gitlab-org%2Frelease-cli/packages/generic/release-cli/latest/release-cli-linux-amd64"
    chmod u+x /usr/bin/release-cli

    docker build -t gardener-extension-provider-warren:latest .

    docker tag gardener-extension-provider-warren:latest ${CI_REGISTRY}/warrenio/library/gardener-extension-provider-warren:${CI_COMMIT_TAG}
    docker tag gardener-extension-provider-warren:latest ${CI_REGISTRY}/warrenio/library/gardener-extension-provider-warren:latest

    docker push ${CI_REGISTRY}/warrenio/library/gardener-extension-provider-warren:${CI_COMMIT_TAG}
    docker push ${CI_REGISTRY}/warrenio/library/gardener-extension-provider-warren:latest

    VERSION="${CI_COMMIT_TAG}" make generate-controller-registration
    sed "s/\[version\]/${CI_COMMIT_TAG}/;/# controller-registration.yaml/r controller-registration.yaml" ./docs/RELEASE_NOTES_TEMPLATE.md > RELEASE_NOTES.md
  release:
    tag_name: $CI_COMMIT_TAG
    name: $CI_COMMIT_TAG
    description: ./RELEASE_NOTES.md
